#include <iostream>
#include <algorithm>
#include <math.h>

using namespace std;

long long sqrt_3(long long x, int ff){ // ff=1 ans^3 >= x, ff=0 ans^3 <= x
    long long l = 0, r = sqrt(x);
    while (l < r-1){
        long long t = (l+r)/2;
        if (t*t*t < x || (ff || t*t*t == x)) l = t;
            else r = t;
    }
    if (ff) return r;
    return l;
}


int main() {
    long long a, b, k;
    cin >> a >> b >> k;
    long long aa = sqrt_3(a, 1), bb = sqrt_3(b, 0), ans = 0;
    //cout << aa << ' ' << bb << '\n';
    for (int i = aa;i <= bb;i++){
        long long l = sqrt(max(i*i*i - k, 1LL)), r = sqrt(i*i*i + k);
        if (l*l < i*i*i - k) l++;
        ans += max(r - l + 1, 0LL);
        //cout << i << ' ' << l << ' ' << r << '\n';
    }
    cout << ans << '\n';
    return 0;
}

