#include <iostream>
#include <algorithm>
#include <math.h>

using namespace std;

long long sqrt_3(long long x){
    long long l = 1, r = sqrt(x);
    r = min(r, 1000001LL);
    while (l < r-1){
        long long t = (l+r)/2;
        if (t*t*t <= x) l = t;
            else r = t;
    }
    return l;
}


int main() {
    long long a, b, k;
    cin >> a >> b >> k;
    long long aa = sqrt_3(a), bb = sqrt_3(b), ans = 0;
    if (aa*aa*aa < a) aa++;
    //cout << aa << ' ' << bb << '\n';
    for (int i = aa;i <= bb;i++){
        long long l = sqrt(max(i*i*i - k, a)), r = sqrt(min(i*i*i + k, b));
        if (l*l < max(i*i*i - k, a)) l++;
        if (r*r > min(i*i*i + k, b)) r--;
        ans += max(r - l + 1, 0LL);
        //cout << i << ' ' << l << ' ' << r << '\n';
    }
    cout << ans << '\n';
    return 0;
}

